unit hiCommutator;

interface

uses Kol,Share,Debug;

type
 THICommutator = class(TDebug)
   private
     FOutCount:byte;
     procedure SetOutCount(value:word);
   public
     _prop_InCount:byte;
     onEvent:array of THI_Event;
     _data_OnOff:THI_Event;
     _data_IndexIn:THI_Event;
     _data_IndexOut:THI_Event;

     procedure doEvent(var Data:TData; Index:word);
     property _prop_OutCount:word write SetOutCount;
 end;

implementation

procedure THICommutator.SetOutCount;
begin
   if Value > 0 then
    begin
      SetLength(onEvent,Value);
      FOutCount := Value;
    end
   else FOutCount := 0;
end;

procedure THICommutator.doEvent;
var
  On,IndOut,IndIn,i:integer;
  dt:TData;
begin
   On := ReadInteger(dt,_data_OnOff,1);
   if On = 0 then exit;
   IndOut := ReadInteger(dt,_data_IndexOut,-1);
   IndIn := ReadInteger(dt,_data_IndexIn,-1);
   if (IndIn = Index) or (IndIn < 0) then
   begin
     if(IndOut >= 0)and(IndOut < FOutCount) then
       begin
         dt := Data;
         _hi_onEvent(onEvent[IndOut],dt);
       end else
       if IndOut < 0 then
         for i := 0 to FOutCount - 1 do
           begin
             dt := Data;
             _hi_onEvent(onEvent[i],dt);
           end;
   end;
end;

end.
